/*
 * SWFxME is an open source solution to extend Flash Lite
 * using J2ME (http server). It is developed to enrich Flash 
 * Lite with certain features which it lacks like writing to 
 * a file, listing a directory etc.Simply , 
 *          Flash Lite + J2ME  = More Fun :)
 * It is quite easy to extend SWFxME , please read documentation for more details.
 * Drop me a mail , if u have further questions or any feedback :
 * @ email : sajisoft@gmail.com
 * @ Author of SWFxME : Sajid Ali Anjum (a.k.a SajiSoft)
 * Credit also goes to : 
 * Felipe Andrade (for his Jarpa project)
 */

package SWFxME;


import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class Main extends MIDlet implements CommandListener, Runnable {
private Form _form;
    private Command _cmdExit;
    private StringItem _status;
    
    /* Few thing to keep in mind while selecting a path :
     * Swf file cannot be copied to any where , few directories
       are restricted by platform. However, if u copied to such a directory
       u get a java.lang.SecurityException: Access Denied Error.
     * Paths should be absolute like this <root>/<directory>/<directory>/.../<name>. 
       For example : "file:///C:/my.swf" or file:///MemoryStick/my.swf" 
       or "file:///SDCard/my.swf" or "file:///CFCard/" 
     */
    // target File Path
    private String _targetFilePath = "file:///C:/data/SWFxME_test.swf";
    
    // Local Port on which we have to bind server
    private String _PORT = "2020";
    
    public void startApp() {
        _form = new Form("SWFxME Debug");        
        _cmdExit = new Command("Exit", Command.EXIT, 1);
        _status = new StringItem("Debug : ", "");
        _form.append(_status);
        _form.addCommand(_cmdExit);
        _form.setCommandListener(this);
        Display.getDisplay(this).setCurrent(_form);
        
        new Thread(this).start();
    }
    
    public void pauseApp() {}
    public void destroyApp(boolean aCond) {}
  

          

         public void run() {
             String err = "";
             String returned = "";
          //copy the resource swf file to local drive   
          err = Resources.getInstance().copyResources(_targetFilePath);
         _status.setText(err);
    
         try {  
                // if error occurs in copying swf file,  dont launch it
               if (Resources.getInstance().error != 1)
       {
            platformRequest(_targetFilePath);
               }     
           // intiliaze the Server with provided Local PORT number
           FLServer.getInstance().init_server(_PORT);
        _status.setText(err + "\nServer Bind Successfully");
        } catch(Exception e) {
            _status.setText(err + "\nError Binding Server/Launching Swf : " + e.toString());
        }
        
        while(FLServer.getInstance()._isListening ==  true)
        {
        try 
        {    
          returned = FLServer.getInstance().listen();
            _status.setText("\n" + returned);
        }catch (Exception e) {
                e.printStackTrace();
            }
        }
        _status.setText("\nStatus : SWFxME Server Closed !");
        
         }
    
    public void commandAction(Command aCmd, Displayable aDisplay) {
        destroyApp(true);
        notifyDestroyed();
    }
}
